package com.wissamfawaz;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Queue;
import java.util.Stack;

public class Main {
	private BTNode<Character> root1;
	private List<Character> depthFirstValuesIter, 
		depthFirstValuesRec;
	private List<Character> breadthFirstValues;
	
	public Main() {
		root1 = new BTNode<>('A');
		BTNode<Character> root1Left = new BTNode<>('B');
		BTNode<Character> root1LeftLeft= new BTNode<>('D');
		BTNode<Character> root1LeftRight = new BTNode<>('E');
		BTNode<Character> root1Right = new BTNode<>('C');
		BTNode<Character> root1RightRight = new BTNode<>('F');
		
		root1.setLeft(root1Left); root1.setRight(root1Right);
		root1Left.setLeft(root1LeftLeft); root1Left.setRight(root1LeftRight);
		root1Right.setRight(root1RightRight);
		
		depthFirstValuesIter = new ArrayList<>();
		depthFirstValuesRec = new ArrayList<>();
		breadthFirstValues = new ArrayList<>();
		
	}

	public static void main(String[] args) {
		Main application = new Main();
		
		application.dfsTraversalIter();
		System.out.println(application.depthFirstValuesIter);
		
		application.dfsTraversalRec();
		System.out.println(application.depthFirstValuesRec);
		
		application.bfsTraversal();
		System.out.println(application.breadthFirstValues);

	}
	
	private void dfsTraversalIter() {
		if(root1 == null) {
			return;
		}
		
		Stack<BTNode<Character>> stack = new Stack<>();
		BTNode<Character> current;
		stack.push(root1);
		
		while(!stack.isEmpty()) {
			current = stack.pop();
			depthFirstValuesIter.add(current.getElement());
			
			if(current.hasRight()) {
				stack.push(current.getRight());
			}
			
			if(current.hasLeft()) {
				stack.push(current.getLeft());
			}
		}	
	}
	
	private void dfsTraversalRec() {
		dfsTraversalRecUtil(root1);
	}
	
	private void dfsTraversalRecUtil(BTNode<Character> node) {
		if(node == null) {
			return;
		}
		depthFirstValuesRec.add(node.getElement());
		dfsTraversalRecUtil(node.getLeft());
		dfsTraversalRecUtil(node.getRight());
			
	}
	
	private void bfsTraversal() {
		if(root1 == null) {
			return;
		}
		
		Queue<BTNode<Character>> queue = new LinkedList<>();
		BTNode<Character> current;
		queue.add(root1);
		
		while(!queue.isEmpty()) {
			current = queue.remove();
			breadthFirstValues.add(current.getElement());
			
			if(current.hasLeft()) {
				queue.add(current.getLeft());
			}
			
			if(current.hasRight()) {
				queue.add(current.getRight());
			}
		}	
	}
	
	
	
}
